#!/bin/bash
BASEDIR=$(pwd)
LOGFLAG="--enable-hamcast-logging"
LIBPATH="$BASEDIR/libhamcast/.libs"

if test $(uname) = "Darwin" ; then
    CONFIGCMD="./configure "
else
    CONFIGCMD="./configure CXXFLAGS=\"-march=native\""
fi

BUILDCMD="if test -e configure.ac ; then autoreconf -fi && $CONFIGCMD && make clean && make; else echo \"!Error! No configure.ac file found.\" exit ; fi"

function verbose_exec()
{
    if eval $1 ; then
        # success
        cmd_success=1
    else
        echo "!Error! In folder $(pwd) executing:"
        echo "\t $1"
        exit
    fi
}

# libhamcast
echo ""
echo ""
echo "Build libhamcast"
verbose_exec "cd $BASEDIR/libhamcast"
verbose_exec "$BUILDCMD"
verbose_exec "cd $BASEDIR"
verbose_exec "export LD_LIBRARY_PATH=$LIBPATH"

# middleware
echo ""
echo ""
echo "Build middleware"
verbose_exec "cd $BASEDIR/middleware"
### if you want to enable logging use the following instead of BUILDCMD
# autoreconf -fi && ./configure $LOGFLAG CXXFLAGS="-march=native" && make
verbose_exec "$BUILDCMD"
verbose_exec "cd $BASEDIR"

# modules
echo ""
echo ""
echo "Build modules ..."
echo ""
echo ""
echo "* [void module]"
verbose_exec "cd $BASEDIR/modules/void"
verbose_exec "$BUILDCMD"

echo ""
echo ""
echo "* [loopback module]"
verbose_exec "cd $BASEDIR/modules/loopback"
verbose_exec "$BUILDCMD"

echo ""
echo ""
echo "* [ipv4 module]"
verbose_exec "cd $BASEDIR/modules/ip"
verbose_exec "$BUILDCMD"

# programs
echo ""
echo ""
echo "Build programs ..."
echo ""
echo ""
echo "* [hc_chat]"
verbose_exec "cd $BASEDIR/programs/hc_chat"
verbose_exec "$BUILDCMD"
echo ""
echo ""
echo "* [hc_status]"
verbose_exec "cd $BASEDIR/programs/hc_status"
verbose_exec "$BUILDCMD"
verbose_exec "cd $BASEDIR"
echo ""
echo ""
echo "DONE ..."
echo ; echo "!REMEMBER TO CONFIGURE HAMcast! Create/edit middleware.ini, see example file."
echo 
