/******************************************************************************\
 *  _   ___     ____  __               _                                      *
 * | | | \ \___/ /  \/  | ___ __ _ ___| |_                                    *
 * | |_| |\     /| |\/| |/ __/ _` / __| __|                                   *
 * |  _  | \ - / | |  | | (_| (_| \__ \ |_                                    *
 * |_| |_|  \_/  |_|  |_|\___\__,_|___/\__|                                   *
 *                                                                            *
 * This file is part of the HAMcast project.                                  *
 *                                                                            *
 * HAMcast is free software: you can redistribute it and/or modify            *
 * it under the terms of the GNU Lesser General Public License as published   *
 * by the Free Software Foundation, either version 3 of the License, or       *
 * (at your option) any later version.                                        *
 *                                                                            *
 * HAMcast is distributed in the hope that it will be useful,                 *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of             *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                       *
 * See the GNU Lesser General Public License for more details.                *
 *                                                                            *
 * You should have received a copy of the GNU Lesser General Public License   *
 * along with HAMcast. If not, see <http://www.gnu.org/licenses/>.            *
 *                                                                            *
 * Contact: HAMcast support <hamcast-support@informatik.haw-hamburg.de>       *
\******************************************************************************/

#ifndef ABSTRACT_SOCKET_HPP
#define ABSTRACT_SOCKET_HPP

#include <boost/intrusive_ptr.hpp>
#include "hamcast/ref_counted.hpp"
#include "hamcast/multicast_packet.hpp"

namespace hamcast { namespace middleware {

class send_job;

/**
 * @brief This interface describes a listener that handles received packages.
 */
struct abstract_socket : public ref_counted
{

    typedef boost::intrusive_ptr<abstract_socket> ptr;

    /**
     * @brief Handle a received multicast package.
     */
    virtual void async_receive(const hamcast::multicast_packet& mp) = 0;

};

} } // namespace hamcast::middleware

#endif // RECEIVE_LISTENER_HPP
