/******************************************************************************\
 *  _   ___     ____  __               _                                      *
 * | | | \ \___/ /  \/  | ___ __ _ ___| |_                                    *
 * | |_| |\     /| |\/| |/ __/ _` / __| __|                                   *
 * |  _  | \ - / | |  | | (_| (_| \__ \ |_                                    *
 * |_| |_|  \_/  |_|  |_|\___\__,_|___/\__|                                   *
 *                                                                            *
 * This file is part of the HAMcast project.                                  *
 *                                                                            *
 * HAMcast is free software: you can redistribute it and/or modify            *
 * it under the terms of the GNU Lesser General Public License as published   *
 * by the Free Software Foundation, either version 3 of the License, or       *
 * (at your option) any later version.                                        *
 *                                                                            *
 * HAMcast is distributed in the hope that it will be useful,                 *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of             *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                       *
 * See the GNU Lesser General Public License for more details.                *
 *                                                                            *
 * You should have received a copy of the GNU Lesser General Public License   *
 * along with HAMcast. If not, see <http://www.gnu.org/licenses/>.            *
 *                                                                            *
 * Contact: HAMcast support <hamcast-support@informatik.haw-hamburg.de>       *
\******************************************************************************/

#ifndef HAMCAST_MIDDLEWARE_SESSION_FWD_HPP
#define HAMCAST_MIDDLEWARE_SESSION_FWD_HPP

#include <utility>
#include <boost/intrusive_ptr.hpp>

#include "hamcast/socket_id.hpp"
#include "hamcast/multicast_packet.hpp"

namespace hamcast { namespace middleware { class session; } }

namespace boost {
void intrusive_ptr_add_ref(hamcast::middleware::session*);
void intrusive_ptr_release(hamcast::middleware::session*);
}

namespace hamcast { namespace middleware {
typedef boost::intrusive_ptr<session> session_ptr;
} }

#endif // HAMCAST_MIDDLEWARE_SESSION_FWD_HPP
