#ifndef TESTOUTPUT_H_
#define TESTOUTPUT_H_

///@author Sebastian Woelke
///@brief Debug output for internet packets

class test_output {
private:
public:

     /**
      * @brief print the packet buf in wireshark style
      */
     static void printBuf(const unsigned char * buf, unsigned int size);

     /**
      * @brief print IPv4 header in cleartext
      */
     static void printPacket_IPv4_Infos(const unsigned char * buf, unsigned int size);

     /**
      * @brief print UDP header in cleartext
      * @param buf musst contain IPv4 header
      */
     static void printPacket_IPv4_UdpInfos(const unsigned char * buf);

     /**
      * @brief print IGMP header in cleartext
      * @param buf musst contain IPv4 header
      */
     static void printPaket_IPv4_IgmpInfos(const unsigned char * buf);

     /**
      * @brief print IPv6 header in cleartext and nextheader infos
      */
     static void printPacket_IPv6_Infos(const unsigned char * buf);

     /**
      * @brief print IPv6 header in cleartext and nextheader infos
      */
     static void printPacket_IPv6_IcmpInfos(const unsigned char * buf);

};
#endif /* TESTOUTPUT_H_ */
