/******************************************************************************\
 *  _   ___     ____  __               _                                      *
 * | | | \ \___/ /  \/  | ___ __ _ ___| |_                                    *
 * | |_| |\     /| |\/| |/ __/ _` / __| __|                                   *
 * |  _  | \ - / | |  | | (_| (_| \__ \ |_                                    *
 * |_| |_|  \_/  |_|  |_|\___\__,_|___/\__|                                   *
 *                                                                            *
 * This file is part of the HAMcast project.                                  *
 *                                                                            *
 * HAMcast is free software: you can redistribute it and/or modify            *
 * it under the terms of the GNU Lesser General Public License as published   *
 * by the Free Software Foundation, either version 3 of the License, or       *
 * (at your option) any later version.                                        *
 *                                                                            *
 * HAMcast is distributed in the hope that it will be useful,                 *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of             *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                       *
 * See the GNU Lesser General Public License for more details.                *
 *                                                                            *
 * You should have received a copy of the GNU Lesser General Public License   *
 * along with HAMcast. If not, see <http://www.gnu.org/licenses/>.            *
 *                                                                            *
 * Contact: HAMcast support <hamcast-support@informatik.haw-hamburg.de>       *
\******************************************************************************/

#include <limits>
#include <iostream>
#include "hamcast/hamcast.hpp"
#include "hamcast/ipc.hpp"

#include <boost/thread.hpp>

using std::cout;
using std::endl;

namespace {

// number of tests
const size_t num_tests = 20;

}

int main()
{

	std::vector<hamcast::ipc::interface_property> vec;
	vec = hamcast::ipc::get_interfaces();
	cout << "list of middleware interfaces:" << endl << endl;
	for (size_t i = 0; i < vec.size(); ++i)
	{
		cout << "interface[id = " << vec[i].id << "]:" << endl
			 << "\tname = " << vec[i].name << endl
			 << "\taddress = " << vec[i].address << endl
			 << "\ttechnology = " << vec[i].technology << endl << endl;
	}

	return 0;
}

